/* MACE_GO: MAximal Clique Enumerater - Greater size/Optimum */
/* ver 1.0 1/Sep/2005 Takeaki Uno   e-mail:uno@nii.jp, 
    homepage:   http://research.nii.ac.jp/~uno/index.html  */
/* This program is available for only academic use, basically.
   Anyone can modify this program, but he/she has to write down 
    the change of the modification on the top of the source code.
   Neither contact nor appointment to Takeaki Uno is needed.
   If one wants to re-distribute this code, do not forget to 
    refer the newest code, and show the link to homepage of 
    Takeaki Uno, to notify the news about this code for the users.
   For the commercial use, please make a contact to Takeaki Uno. */


#ifndef _mace_go_c_
#define _mace_go_c_

#define WEIGHT_DOUBLE
#define MACEGO_MAX 8

#include"sgraph.c"
#include"problem.c"


//int **PP->shift;    /* pointers to the positions of the current processing items in each transaction */


void MACEGO_error (){
  ERROR_MES = "command explanation";
  print_err ("mace_go MCqVe [options] input-filename [output-filename]\n\
%%:show progress, _:no message, +:write solutions in append mode\n\
M:enumerate maximal cliques, O:find maximum cliques\n\
e:edge_list format for input file\n\
[options]\n\
-l [num]:enumerate maximal cliques of size at least [num]\n\
-# [num]:stop after outputting [num] solutions\n\
-, [char]:give the separator of the numbers in the output\n\
-Q [filename]:replace the output numbers according to the permutation table given by [filename]\n\
# the 1st letter of input-filename cannot be '-'.n\
# if the output file name is -, the solutions will be output to standard output.\n");
  EXIT;
}


/***************************************************/
/*  read parameters from command line              */
/***************************************************/
void MACEGO_read_param (int argc, char *argv[], PROBLEM *PP){
  ITEMSET *II=&PP->II;
  int c=1;
  if ( argc < c+2 ){ MACEGO_error (); return; }
  II->lb = 1; II->frq = II->frq_lb = 0.0;

  if ( !strchr (argv[c], '_') ){ II->flag |= SHOW_MESSAGE; PP->SG.flag |= SHOW_MESSAGE; }
  if ( strchr (argv[c], '%') ) II->flag |= SHOW_PROGRESS;
  if ( strchr (argv[c], '+') ) II->flag |= ITEMSET_APPEND;
  if ( strchr (argv[c], 'M') ) PP->problem = PROBLEM_MAXIMAL;
  else if ( strchr (argv[c], 'O') ) PP->problem = MACEGO_MAX;
  else error ("C command has to be specified", EXIT);
  if ( strchr (argv[c], 'e') ) PP->SG.flag |= LOAD_ELE;
  c++;

  while ( argv[c][0] == '-' ){
    switch (argv[c][1]){
      case 'l': II->lb = atoi (argv[c+1]);
      break; case 'm': II->frq = atof(argv[c+1]);   // lower bound for weight
      break; case 'w': PP->SG.edge.rwfname = argv[c+1]; II->frq = 0;
          if ( PP->problem & PROBLEM_MAXIMAL ) II->flag |= ITEMSET_FREQ;
      break; case '#': II->max_solutions = atoi(argv[c+1]);
      break; case ',': II->separator = argv[c+1][0];
      break; case 'Q': PP->outperm_fname = argv[c+1];
      break; default: goto NEXT;
    }
    c += 2;
    if ( argc < c+1 ){ MACEGO_error (); return; }
  }

  NEXT:;
  PP->SG.fname = argv[c];
  if ( argc>c+1 ) PP->output_fname = argv[c+1];
}


// v.end: }[N̑B݂̉̃TCY ȂAANeBui݌ĂOtɊ܂܂jANeBuȒ_́Aitemcand Ɋi[B
//  eŃANeBuɂȂƂ݂̂CNgčXVBIɂ̓fNg
// v.v: }i[BANeBuȂƂ낪Oɗ悤ɕāAinduced subgraph \Bieōsj  IɌɖ߂KvȂ
//    }iאڃXgj́A_̑傫Ń\[gĂȂƂɒ
// v.t: ANeBuȕ̍Ō̗vfBeŁAۂɍXVAIɌɖ߂Bɖ߂Ƃɂv.end ANeBuł肽ǂ邱ƂsA̒lL邱Ƃ͂ȂB
//   ɖ߂ƂA݉̃TCY0 ͓̎ʈBz|C^̍𗘗pĕ

// v[jÓA钸_ v ɗאڂ}AANeBü̍ŏ̕Ɍł߁AɂĂ͍ċAsȂƂŎB
// CAND  }XǵA[vɗאڂ]AivjAvɗאڂȂ̂Ƀ\[gAƂŕׂĂBv ̍ċAÍACAND.t CNgA}XgɂĂ v ł̂t CNgBŃOt v ǉ̂ƓƂɂȂB

// II.add ɁẢ݂ɗאڂ钸_SĂi[Bgċɑ含𔻒肷B

// PP->itemcand: vertices to be added (only the second part)
// PP->II.add: all vertices adjacent to 
QUEUE *MACEGO_p;
int MACEGO_cmp (const void *x, const void *y){
  if ( MACEGO_p[*((QUEUE_INT *)x)].s > MACEGO_p[*((QUEUE_INT *)y)].s ) return (-1);
  else if ( MACEGO_p[*((QUEUE_INT *)x)].s < MACEGO_p[*((QUEUE_INT *)y)].s ) return (1);
  else if ( *((QUEUE_INT *)x) < *((QUEUE_INT *)y) ) return (-1);
  else return (1);
}

/* shift the vertices in Q to the end, that are marked. move v to the boundary */
void MACEGO_sub (PROBLEM *PP, QUEUE *Q, QUEUE_INT v){
  QUEUE_INT *z, *y, *yy= Q->v, t=PP->II.itemset.t+2;
  QUEUE *E = PP->SG.edge.v;
  MQUE_FLOOP (*Q, y)
      if ( E[*y].end == t ){ if ( y!=yy ) SWAP_QUEUE_INT (*y, *yy); yy++; }
  if ( yy+1<y ){
    FLOOP (z, yy+1, y)
        if ( *z == v ){ SWAP_INT (*yy, *z); break; }   // move v to the earliest
  if (1|| PP->problem & MACEGO_MAX )
    qsort (yy+1, y-yy-1, sizeof(QUEUE_INT), MACEGO_cmp);
//    qsort_QUEUE_INT (yy+1, y-yy-1, 1);
  }
  Q->t = yy - Q->v;
}
/* shift the vertices in Q to the end, that are marked */
void MACEGO_sub2 (PROBLEM *PP, QUEUE *Q){
  QUEUE_INT *y, *yy=Q->v, t=PP->II.itemset.t+2;
  QUEUE *E = PP->SG.edge.v;
  MQUE_FLOOP (*Q, y)
      if ( E[*y].end == t ){ if ( y!=yy ) SWAP_QUEUE_INT (*y, *yy); yy++; }
  Q->t = yy - Q->v;
}  
void MACEGO_recov (PROBLEM *PP, QUEUE *Q){
  QUEUE_INT *y, t=PP->II.itemset.t+1;
  QUEUE *E = PP->SG.edge.v;
  for (y=Q->v+Q->t ; E[*y].end==t ; y++);
  Q->t = y - Q->v;
}

// remove the small degree vertices
void MACEGO_reduce_sub (PROBLEM *PP, QUEUE_INT v){
  QUEUE *Q = PP->SG.edge.v;
  QUEUE_INT i, u;
// printf ("red %d, %d:%d\n", v, Q[v].t, PP->II.lb);
  for (i=0 ; Q[u = Q[v].v[i]].end == PP->II.itemset.t+1 ; i++)
      if ( Q[u].t>0 && --Q[u].t < PP->II.lb ) MACEGO_reduce_sub (PP, u);
  Q[v].t = 0;
}
void MACEGO_reduce (PROBLEM *PP, QUEUE *prv){
  QUEUE *Q = PP->SG.edge.v;
  QUEUE_INT *v, *y, *yy;
  MQUE_FLOOP (*prv, v)
      if ( Q[*v].t < PP->II.lb ){ MACEGO_reduce_sub (PP, *v); }
  MQUE_FLOOP (*prv, v){
    for (y=yy=Q[*v].v ; Q[*y].end == PP->II.itemset.t+1 ; y++){
      if ( Q[*y].t > 0 ) // compute N[*x]\cap prv
          if ( y != yy ) SWAP_QUEUE_INT (*y, *yy); yy++;
    }
  }
}

/******************************************************************/
/* iteration of clique enumeration   */
/******************************************************************/
void MACEGO_max (PROBLEM *PP, QUEUE *prv){
  ITEMSET *II=&PP->II;
  QUEUE_INT *x, *v, u, m=0, p=*(prv->v), pp=0, pt = prv->t;
  QUEUE *Q = PP->SG.edge.v;
  double f=0, *rw = PP->SG.edge.rw;
  
//printf ("%d\n", II->itemset.t + II->lb );
//if ( II->iters % 10000 == 0 ) printf ("%d\n", II->lb+II->itemset.t-2);

  II->iters++;

printf ("==== %4.0f,  %4.0f ::: ", II->frq, II->frq_lb); QUEUE_print__ (&II->itemset);
MQUE_FLOOP (*prv, v) printf ("%d,", *v); printf ("\n");

//printf ("======== %p", Q[47].v); QUEUE_print__ (&Q[47]);
//FLOOP (u,0, 100) printf ("%d,", prv->v[u]); printf ("======= %d\n", prv->t);
//FLOOP (u,0, 20) printf ("%d..", Q[17].v[u]); printf ("======= %d\n", Q[17].t);

//  MACEGO_reduce (PP, prv);

    // choose the maximum degree vertex p
  MQUE_FLOOP (*prv, v) if (Q[*v].t > m){ m= Q[*v].t; pp = p = *v; }
  if ( rw ){
    MQUE_FLOOP (*prv, v) if (rw[*v] > f){ f = rw[*v]; pp = *v; }
//  if ( m < II->lb ){ printf ("pruned: %d %d\n", prv->t, II->lb-m); return; }  // every vertex violates the lower bound
  } else {
//  if ( m < II->lb ){ printf ("pruned: %d %d\n", prv->t, II->lb-m); return; }  // every vertex violates the lower bound
    if ( m < II->lb ) return;  // every vertex violates the lower bound
  }
  if ( m == 0 ){
    if ( (!rw && II->lb < 1) || (rw && II->frq+f > II->frq_lb) ){
      if ( rw ) II->frq_lb = II->frq+f; else II->lb = 1;
      QUEUE_cpy (&PP->itemcand, &PP->II.itemset);
      QUE_INS (PP->itemcand, pp);
    }
    return;
  }
    // sort the edge list according neighbors of p

// for each edge array list adjacent to v, partition the vertices in it so that vertices adjacent to v are lacated at the first half. the size (.t) is changed to the end of the first half
// t has to be "itemset.t"
//  MQUE_FLOOP (Q[p], x){ Q[*x].end++; Q[*x].s = Q[*x].t; }   // increment the mark, adjacent to v
  MQUE_FLOOP (Q[p], x) Q[*x].end++;   // increment the mark, adjacent to v
  MQUE_FLOOP (*prv, x) if ( *x != p ) Q[*x].s = Q[*x].t;
  MQUE_FLOOP (*prv, x) if ( *x != p ){
//    MACEGO_sub (PP, &Q[*x], p);
//    if ( Q[*x].end == II->itemset.t+1 )
//        while ( Q[Q[*x].v[Q[*x].t]].end == II->itemset.t+1 && Q[*x].v[Q[*x].t]<*x ) Q[*x].t++;
    MACEGO_sub (PP, &Q[*x], p);
    if ( Q[*x].end == II->itemset.t+1 )

        while ( Q[*x].t < Q[*x].s && (Q[u=Q[*x].v[Q[*x].t]].s > Q[*x].s || (Q[u].s == Q[*x].s && u<*x)) ) Q[*x].t++;
//        while ( Q[*x].t < Q[*x].s && Q[*x].v[Q[*x].t]<*x ) Q[*x].t++;
//        while ( Q[Q[*x].v[Q[*x].t]].end == II->itemset.t+1 && Q[*x].v[Q[*x].t]<*x ) Q[*x].t++;
  }
  MACEGO_sub (PP, prv, p);
  FLOOP (m, prv->t, pt){
    prv->t = m-1;
if ( II->itemset.t == 0 ){ MQUE_FLOOP (*prv, v) printf ("%d:", *v); printf ("\n"); }
    u = prv->v[m];
    if ( rw ){
      f = 0;
      MQUE_FLOOP (Q[u], x) f += rw[*x];
      if ( II->frq+f < II->frq_lb ) continue;   // violate the lower bound
    } else if ( Q[u].t < II->lb ) continue;   // violate the lower bound
//printf ("loop for %d %d \n", II->itemset.t, u);
    if ( Q[u].t > 0 ){
      if ( u != p ){
//        while ( Q[Q[u].v[Q[u].t]].end == II->itemset.t+1 && Q[u].v[Q[u].t] < u ){ printf ("come\n"); Q[u].t++; }
        MQUE_FLOOP (Q[u], x){
//          FLOOP (common_INT, 0, Q[*x].t) if ( Q[*x].v[common_INT] == u ){ printf ("KKKKK %d %d:::   ", *x,Q[*x].t - common_INT); Q[*x].s = 0; QUEUE_print__ (&Q[*x]); }
          while ( Q[*x].v[Q[*x].t] != u ) Q[*x].t++;
//          if ( Q[*x].t >= Q[*x+1].v - Q[*x].v ){ printf ("okasii %d [%d,%d]:::   ", *x,Q[*x].t, Q[*x+1].v - Q[*x].v-1 ); QUEUE_print__ (&Q[*x]); }
//         while ( Q[*x].v[Q[*x].t] != u && Q[Q[*x].v[Q[*x].t]].end == II->itemset.t+1 ) Q[*x].t++;
          Q[*x].end++;   // increment the mark, adjacent to v
        }
        MQUE_FLOOP (Q[u], x) MACEGO_sub2 (PP, &Q[*x]);
      }
      QUE_INS (II->itemset, u);  // insert vertex
      II->lb--; if ( rw ) II->frq += rw[u];
        MACEGO_max (PP, &Q[u]);    // recursive call
      II->lb++; if ( rw ) II->frq -= rw[u];
      II->itemset.t--;
//printf ("ret: %d\n", u);
      MQUE_FLOOP (Q[u], x) Q[*x].end--;    // decrement the mark, to recover
    } else if ( rw && II->frq + rw[u] > II->frq_lb ){
      II->frq_lb = II->frq + rw[u];
      QUE_INS (II->itemset, u);  // insert vertex
      QUEUE_cpy (&PP->itemcand, &PP->II.itemset);
      II->itemset.t--;
/*     else if ( !rw && II->lb <= 0 ){
      II->lb = 1;
      QUE_INS (II->itemset, u);  // insert vertex
      QUEUE_cpy (&PP->itemcand, &PP->II.itemset);
      II->itemset.t--;
*/
    }
  }
  prv->t = pt;
}

/******************************************************************/
/* iteration of clique enumeration   */
/******************************************************************/
void MACEGO_iter (PROBLEM *PP, QUEUE *prv){
  ITEMSET *II=&PP->II;
  QUEUE_INT *x, *v, *vv, *y=prv->v, u, m=0, p=*y, t=II->itemset.t+2;
  QUEUE_ID pt=prv->t, it=PP->itemcand.t;
  QUEUE *Q = PP->SG.edge.v;
  double f=0, ff=0, *rw = PP->SG.edge.rw;

  II->iters++;
//QUEUE_print__ (&II->itemset);
//printf ("###  "); QUEUE_print (prv); 

    // make the induced graph by *prv, and choose the maximum degree vertex p
  MQUE_FLOOP (*prv, x) Q[*x].end++;   // mark vertices in prv
  MQUE_FLOOP (*prv, x){
    if ( Q[*x].t == 0 ){  // adding *x generates a maximal clique!
      Q[*x].s = 0;
      if ( (!rw && II->lb <= 1) || (rw && II->frq+rw[*x] >= II->frq_lb) ){  // satisfies lower bound constraint
        QUE_INS (II->itemset, *x);  
        ITEMSET_output_itemset (II, NULL, 0);
        II->itemset.t--;
      }
    } else {
      f = 0; vv = Q[*x].v;
      MQUE_FLOOP (Q[*x], v){
        if ( Q[*v].end == t ){ // compute N[*x]\cap prv
          if ( rw ) f += rw[*vv];
          if ( v != vv ) SWAP_QUEUE_INT (*v, *vv); vv++;
        }
      }
      if ( (Q[*x].s = vv-Q[*x].v) > m ){ m = Q[*x].s; p = *x; }
      if ( rw && f > ff ) ff = f;
      if ( vv > Q[*x].v ){
        if ( x>y ) SWAP_QUEUE_INT (*x, *y);
        y++;
      }
    }
  }
  MQUE_FLOOP (*prv, x) Q[*x].end--;  // delete marks
  prv->t = y - prv->v;  // pass vetices that were shifted to the end
  if ( rw ){ if ( II->frq + ff < II->frq_lb ) return;
  } else if ( m < MAX(1,II->lb-1) ) return;   // every vertex violates the lower bound

//  if ( II->lb >= 2 ) 
//      MACEGO_rm_non_common_edge (G, II->lb, &PP->itemcand, PP->occ_w, &PP->itemjump);


// for each edge array list of vertex adjacent to p, partition the vertices in it so that vertices adjacent to p are lacated at the first half. the size (.t) is changed to the end of the first half
// t has to be "itemset.t"
  MQUE_FLOOP (Q[p], x) if ( Q[*x].end == t-1 ) Q[*x].end++;   // increment the mark, adjacent to p
  MACEGO_sub (PP, prv, p);

//  reallocz (PP->itemary, PP->root, PP->dir+prv->t ,EXIT); //
  FLOOP (m, prv->t, pt){
    u = prv->v[m];
//printf ("loop for %d\n", u);
//    if ( Q[u].s < II->lb-1 ) continue;
    if ( u != p ){
      MQUE_FLOOP (Q[u], x) if ( Q[*x].end == t-1 ) Q[*x].end++;   // increment the mark, adjacent to p
      MACEGO_sub2 (PP, prv);  // shift the vertices adjacent to u, to the end
    }
    MQUE_FLOOP (Q[u], x){
      if ( Q[*x].end == t ){
//        PP->itemary[PP->dir++] = Q[*x].t;
        MACEGO_sub2 (PP, &Q[*x]);
      }
    }
    MACEGO_sub2 (PP, &PP->itemcand);
    QUE_INS (II->itemset, u);  // insert vertex
//printf ("rec: %d\n", u);
    II->lb--; if ( rw ) II->frq += rw[u];
      MACEGO_iter (PP, prv);    // recursive call
    II->lb++; if ( rw ) II->frq -= rw[u];
    II->itemset.t--;
//printf ("return: %d\n", u);
    PP->itemcand.t = it;
    prv->t = m+1;
    MQUE_FLOOP (Q[u], x) if ( Q[*x].end == t ) MACEGO_recov (PP, &Q[*x]);
//    MQUE_BLOOP (Q[u], x) if ( Q[*x].end == t ) Q[*x].t = PP->itemary[--PP->dir];
    MQUE_FLOOP (Q[u], x) if ( Q[*x].end == t ) Q[*x].end--;    // decrement the mark, to recover
//QUEUE_print__ (&Q[2]);
//FLOOP (common_INT, 0, 15) printf ("(%d,%d):", common_INT, Q[common_INT].end); printf ("\n");
  }
}

/***************************************************/
/*  main routine                                   */
/***************************************************/
int MACEGO_main (int argc, char *argv[]){
  PROBLEM PP;
  SGRAPH *G=&PP.SG;
  QUEUE_INT i;
  
  PROBLEM_init (&PP);
  MACEGO_read_param (argc, argv, &PP);
if ( ERROR_MES ) return (1);

  G->flag |= LOAD_INCSORT + LOAD_RM_DUP + LOAD_EDGE;
  if ( PP.problem & MACEGO_MAX ) PP.II.flag |= ITEMSET_ADD;
  PROBLEM_load (&PP);  if (ERROR_MES) return(1);
  SGRAPH_rm_selfloop (G);
  if (G->edge.rwfname) SETFAMILY_load_row_weight (&G->edge);

  PROBLEM_alloc (&PP, G->edge.t, G->edge.t, G->edge.eles, NULL, PROBLEM_ITEMCAND +PROBLEM_ITEMJUMP);  if (ERROR_MES) return(1);  // +PROBLEM_OCC_W
  FLOOP (i, 0, G->edge.t){
    G->edge.v[i].end = 1;  // pur vertex mark
    G->edge.v[i].v[G->edge.v[i].t] = G->edge.t; // put endmark
    PP.itemcand.v[i] = PP.itemjump.v[i] = i;// init CAND
  }
  G->edge.v[G->edge.t].end = 0;
  PP.itemjump.t = G->edge.t;
  if ( !(PP.problem & MACEGO_MAX) ) PP.itemcand.t = G->edge.t;
  MACEGO_p = G->edge.v;
//  MACEGO_rm_small_deg (G, PP.II.lb);
//  SGRAPH_sort_node (G, 1);
//  ST_MAX (m, pivot, G->edge.v, t, 0, G->edge.t);
  
//SGRAPH_print (G);
  if ( PP.problem & MACEGO_MAX ){
    MACEGO_max (&PP, &PP.itemjump);
    if ( PP.SG.edge.rw ) printf ("%f: ", PP.II.frq_lb);
    QUEUE_print (&PP.itemcand);
    if ( PP.II.flag&SHOW_MESSAGE ) printf ("iters=%lld\n", PP.II.iters);
  } else { MACEGO_iter (&PP, &PP.itemjump); ITEMSET_last_output (&PP.II); }
  
  PROBLEM_end (&PP);
  return (ERROR_MES?1:0);
}

/*******************************************************************************/
#ifndef _NO_MAIN_
#define _NO_MAIN_
int main (int argc, char *argv[]){
  return (MACEGO_main (argc, argv) );
}
#endif
/*******************************************************************************/


#endif

